Subject: bug#74217: Bootstrapping Zig with no Binary Blobs

From: Motiejus Jakštys <[email-masked]>
Date: Sun, 1 Dec 2024 21:32:01 +0200

On Fri, Nov 29, 2024 at 2:25 PM Hilton Chain <[email-masked]> wrote:
>
> On Fri, 29 Nov 2024 04:53:57 +0800,
> Motiejus Jakštys wrote:
> >
> > [1  <text/plain; UTF-8 (quoted-printable)>]
> > On Thu, Nov 28, 2024 at 5:20 PM Hilton Chain <[email-masked]> wrote:
> > > Thanks!  Then I'll keep abilists removed before we can reproduce one :)
> >
> > OK here it is for 0.11:
> >
> > 1. check out glibc-abi-tool 13576b1ea957882be7ff2c99f4cdc27454930219
> > 2. rm -fr glibc/2.3{5,6,7,8}
> > 3. apply the attached patch.
> > 4. /path/to/zig-0.11/bin/zig run consolidate.zig
> >
> > ... which results in abilists
> > 546e3c64b5c972b45c4c5c3e81fa1c73282db9377d57ae870d7abcb276f9605c.
> >
> > Motiejus
> > [2 Backport-consolidate.zig-to-zig-0.11.0.patch <text/x-patch; US-ASCII (base64)>]
> > From 23135302904467aa2e814500af6327408c46f52e Mon Sep 17 00:00:00 2001
> > From: =?UTF-8?q?Motiejus=20Jak=C5=A1tys?= <[email-masked]>
> > Date: Thu, 28 Nov 2024 22:52:13 +0200
> > Subject: [PATCH] Backport consolidate.zig to zig 0.11.0
> >
> > ---
> >  consolidate.zig | 8 ++------
> >  1 file changed, 2 insertions(+), 6 deletions(-)
>
> Thanks very much!  I have added abilists for 0.9 and 0.10 as well.

For the record, I have smoke-tested abilists on 0.9, 0.10, 0.11.0,
0.12.1 and 0.13. The test was as follows:

1. create a "hello world" C program that uses printf.
2. /gnu/.../zig-VERSION/bin/zig cc -target x86_64-linux-gnu.2.28
hello.c -o hello
3. readelf -Ws hello
4. observe line (3) has line "[email-masked]".
5. run `hello` on non-guix and observe expected output.

Regards,
Motiejus